=== modified file 'NEWS'
--- NEWS	2011-03-25 11:38:43 +0000
+++ NEWS	2011-03-24 23:02:29 +0000
@@ -42,9 +42,6 @@
     - Fix escaping of filenames in revision views.
       (William Grant, #740142)
 
-    - Fix support for displaying foreign revision ids.
-      (Jelmer Vernooij, #736026)
-
 
 1.18 [10Nov2010]
 ----------------

=== modified file '__init__.py'
--- __init__.py	2011-04-12 10:18:52 +0000
+++ __init__.py	2011-03-19 08:35:57 +0000
@@ -86,10 +86,7 @@
         config = LoggerheadConfig(argv)
         setup_logging(config, init_logging=False, log_file=sys.stderr)
         app = BranchesFromTransportRoot(transport.base, config)
-        # Bug #758618, HeadMiddleware seems to break HTTPExceptionHandler from
-        # actually sending appropriate return codes to the client. Since nobody
-        # desperately needs HeadMiddleware right now, just ignoring it.
-        # app = HeadMiddleware(app)
+        app = HeadMiddleware(app)
         app = HTTPExceptionHandler(app)
         serve(app, host=host, port=port)
 

=== modified file 'loggerhead/history.py'
--- loggerhead/history.py	2011-03-25 13:09:10 +0000
+++ loggerhead/history.py	2011-03-16 14:43:36 +0000
@@ -720,11 +720,7 @@
           # tag.sort_* functions expect (tag, data) pairs, so we generate them,
           # and then strip them
           tags = [(t, None) for t in self._branch_tags[revision.revision_id]]
-          sort_func = getattr(tag, 'sort_natural', None)
-          if sort_func is None:
-              tags.sort()
-          else:
-              sort_func(self._branch, tags)
+          tag.sort_natural(self._branch, tags)
           revtags = u', '.join([t[0] for t in tags])
 
         entry = {
@@ -742,8 +738,7 @@
             'tags': revtags,
         }
         if isinstance(revision, bzrlib.foreign.ForeignRevision):
-            foreign_revid, mapping = (
-                revision.foreign_revid, revision.mapping)
+            foreign_revid, mapping = (rev.foreign_revid, rev.mapping)
         elif ":" in revision.revision_id:
             try:
                 foreign_revid, mapping = \

=== modified file 'loggerhead/tests/test_history.py'
--- loggerhead/tests/test_history.py	2011-03-25 13:09:10 +0000
+++ loggerhead/tests/test_history.py	2011-03-16 14:43:36 +0000
@@ -17,14 +17,8 @@
 
 """Direct tests of the loggerhead/history.py module"""
 
-from bzrlib.foreign import (
-    ForeignRevision,
-    ForeignVcs,
-    VcsMapping,
-    )
-
 from datetime import datetime
-from bzrlib import tag, tests
+from bzrlib import tests
 
 from loggerhead import history as _mod_history
 
@@ -230,12 +224,9 @@
         b.tags.set_tag('tag-2', rev.revision_id)
         b.tags.set_tag('Tag-10', rev.revision_id)
         change = history._change_from_revision(rev)
-        # If available, tags are 'naturally' sorted. (sorting numbers in order,
-        # and ignoring case, etc.)
-        if getattr(tag, 'sort_natural', None) is not None:
-            self.assertEqual('tag-1, tag-2, Tag-10', change.tags)
-        else:
-            self.assertEqual('Tag-10, tag-1, tag-2', change.tags)
+        # tags are 'naturally' sorted, sorting numbers in order, and ignoring
+        # case, etc.
+        self.assertEqual('tag-1, tag-2, Tag-10', change.tags)
 
     def test_committer_vs_authors(self):
         tree = self.make_branch_and_tree('test')
@@ -300,29 +291,3 @@
         self.assertEqual('Z', start_revid)
         self.assertEqual(set([history._rev_indices[x] for x in 'ZYXWVU']),
                          accessed)
-
-
-class TestHistoryGetChangedUncached(TestCaseWithExamples):
-
-    def test_native(self):
-        history = self.make_linear_ancestry()
-        changes = history.get_changes_uncached(['rev-1', 'rev-2'])
-        self.assertEquals(2, len(changes))
-        self.assertEquals('rev-1', changes[0].revid)
-        self.assertEquals('rev-2', changes[1].revid)
-        self.assertIs(None, getattr(changes[0], 'foreign_vcs', None))
-        self.assertIs(None, getattr(changes[0], 'foreign_revid', None))
-
-    def test_foreign(self):
-        # Test with a mocked foreign revision, as it's not possible
-        # to rely on any foreign plugins being installed.
-        history = self.make_linear_ancestry()
-        foreign_vcs = ForeignVcs(None, "vcs")
-        foreign_vcs.show_foreign_revid = repr
-        foreign_rev = ForeignRevision(("uuid", 1234), VcsMapping(foreign_vcs),
-            "revid-in-bzr", message="message",
-            timestamp=234423423.3)
-        change = history._change_from_revision(foreign_rev)
-        self.assertEquals('revid-in-bzr', change.revid)
-        self.assertEquals("('uuid', 1234)", change.foreign_revid)
-        self.assertEquals("vcs", change.foreign_vcs)

=== modified file 'loggerhead/tests/test_load_test.py'
--- loggerhead/tests/test_load_test.py	2011-03-25 14:14:42 +0000
+++ loggerhead/tests/test_load_test.py	2011-02-10 00:49:06 +0000
@@ -20,7 +20,7 @@
 from bzrlib import tests
 from bzrlib.tests import http_server
 
-from loggerhead import load_test
+from bzrlib.plugins.loggerhead.loggerhead import load_test
 
 
 empty_script = """{

